#include <iostream>
#include <omp.h>

#include <kv/interval.hpp>
#include <kv/rdouble.hpp>
#include <kv/dd.hpp>
#include <kv/rdd.hpp>
#include <kv/mpfr.hpp>
#include <kv/rmpfr.hpp>

#include <vcp/imats.hpp>
#include <vcp/matrix.hpp>
#include <vcp/matrix_assist.hpp>

//using namespace vcp;
using namespace std;
using namespace kv;

int main(void){
    cout << setprecision(5);
    int n = 20;
    vcp::matrix< double > A, R, I, b, x;
    vcp::matrix< interval< double > > A_int, R_int, I_int, b_int, x_int, G, r, eyevec, error56;
    interval< double > G_norm, r_norm, D, error53, max_error;

    // A.rand(n,n); // random 
    // b.rand(n,1); // random
    // b.ones(n,1); b = A*b; // to set the exact solution x~[1,1,...,1]
    load(A,"A");
    load(b,"b");
    R = inv(A); // approximate inverse of A
    I.eye(n); // identity
    x = R*b; // approximate solution
    // cout << x << endl;
    
    
    vcp::interval(A, A_int);
    vcp::interval(b, b_int);
    vcp::interval(R, R_int);
    vcp::interval(I, I_int);
    vcp::interval(x, x_int);
    
    G = abs(R_int*A_int - I_int);
    r = abs(R_int*(b_int - A_int*x_int));
    
    G_norm = norminf(G)(0,0);
    r_norm = norminf(r)(0,0);
    
    D = 1 - G_norm;
    if (D > 0){
        error53 = r_norm/D;
        cout << "error using Theorem 5.3 <= " << error53.upper() << endl;

        // eyevec.ones(n,1);
        // error56 = abs(r + error53 * G * eyevec);
        // cout << "using Theorem 5.3 <= \n" << error56 << endl;
    } else{
        cout << "Failed in verification." << endl;
    }
    return 0;
    
}
